#include <math.h>
#include <mem.h>
#include <stdlib.h>
#include "dip.h"
#include "feedback.h"
#include "graph.h"
#include "music.h"

char zscreen[65536+64*256], zscreen2[65536+64*256];
char *fscreen=zscreen+8*256, *fscreen2=zscreen2+8*256;

point dots[1600];
point dots2[1600];
bitmap dog[2];
int sine[2048];
static int bar=0, angle=0, color=50;

void feedback(char *dest, char *src, int angle)
{ int i, j, n=0, x, y, x1, y1, x2, y2, q, a1, a2, xv, yv, z, zz;
  char r;

  z=4-dip[FEEDBACK_SPEED_1];
  zz=15+dip[FEEDBACK_SPEED_2];

  a1=sine[angle+256];
  a2=sine[angle];
  for(i=0; i<256; i++)
  { x=((-128)*zz)>>z;
    y=((i-128)*zz)>>z;
    x1=((a1*x))-((a2*y));
    y1=((a1*y))+((a2*x));
    x=((128)*zz)>>z;
    y=((i-128)*zz)>>z;
    x2=((a1*x))-((a2*y));
    y2=((a1*y))+((a2*x));
    xv=(x2-x1)/256;
    yv=(y2-y1)/256;
    for(j=0; j<256; j++)
    { x1+=xv;
      y1+=yv;
      q=(((y1>>15)+128)<<8)+(x1>>15)+128;
      r=(src[q+1]+src[q-1]+src[q-256]+src[q+256])>>2;
      if(r) r--;
      dest[n++]=r;
    }
  }
}

void rotatepoints(point *dest, point *src, int n, int ax, int ay)
{ int i;
  double tox, toy, toz;
  double tx, ty, tz;
  double cox, six, coy, siy;

  cox=cos(ax*3.1415/180);
  six=sin(ax*3.1415/180);
  coy=cos(ay*3.1415/180);
  siy=sin(ay*3.1415/180);

  for(i=0; i<n; i++)
  { tox=src[i].x;
    toy=src[i].y;
    toz=src[i].z;
    tz=toy*cox-toz*six;
    ty=toz*cox+toy*six;
    toy=ty; toz=tz;
    tx=tox*coy-toy*siy;
    ty=tox*siy+toy*coy;
    dest[i].x=tx;
    dest[i].y=ty;
    dest[i].z=tz;
  }
  dest[i].end=1;
}
/*
void rotatepoints(point *dest, point *source, int anx, int any, int anz)
{ int i;
  point interm, interm2;

  for(i=0; !source[i-1].end; i++)
  { interm.x=source[i].x;
    interm.y=sine[(anx+256)%1024]*source[i].y/32767-sine[anx%1024]*source[i].z/32767;
    interm.z=sine[anx%1024]*source[i].y/32767+sine[(anx+256)%1024]*source[i].z/32767;

    interm2.x=sine[(any+256)%1024]*interm.x/32767-sine[any]*interm.z/32767;
    interm2.y=interm.y;
    interm2.z=sine[(any+256)%1024]*interm.z/32767+sine[any]*interm.x/32767;

    dest[i].x=sine[(anz+256)%1024]*interm2.x/32767-sine[anz]*interm2.y/32767;
    dest[i].y=sine[(anz+256)%1024]*interm2.y/32767+sine[anz]*interm2.z/32767;
    dest[i].z=interm2.z;
    dest[i].end=source[i].end;
  }
}
*/
void plotpoint(char *screen, point pt, char color)
{ int x, y;

  x=256*pt.x/(pt.z-256)+128;
  y=256*pt.y/(pt.z-256)+128;
  if(x>0 && x<319 && y>0 && y<199)
  { screen[y*256+x]=color;
    screen[y*256+x+1]=color;
    screen[y*256+x-1]=color;
    screen[y*256+x+256]=color;
    screen[y*256+x-256]=color;
  }
}

void advfeedback(int frame)
{ static xa=0, ya=0, za=0;
  static int n=0, q=0, b=1;

  updateinfo();

  if(!n) n=order;
  if(n==order-1)
  { b=!b;
    if(!q) angle=0;
    putbitmap(vscreen, 0, 0, dog+b);
    n++;
    q=1;
  }
  if(q)
    bar+=frame;

  xa+=frame, ya+=frame*2, za+=frame*3;
  xa%=1024, ya%=1024, za%=1024;
  rotatepoints(dots2, dots, 100, xa, ya);
  angle+=frame;
  color+=frame;
  if(color>512) color=512;
}

void initfeedback()
{ int i, n=0;

  for(i=0; i<2048; i++)
    sine[i]=sin(i*3.1415/512)*32767;
  for(i=0; i<100; i++)
  { dots[n].x=sine[i*1024/100]/800;
    dots[n].y=sine[((i*1024/100)+256)%1024]/800;
    dots[n++].z=0;
  }
  dots[n].end=1;

  dog[0]=loadpcxlump("image.dog2");
  dog[1]=loadpcxlump("image.dog1");
}

void drawfeedback(char *vscreen)
{ int i;
  static f=0;

  if(!f)
    putbitmap(vscreen, 0, 0, dog+1);

  for(i=0; !dots2[i].end; i++)
    plotpoint(fscreen, dots2[i], color/4);
  if(bar)
    memset(fscreen+(bar%512)*128, 127, 256*16);
  feedback(fscreen2, fscreen, angle/3);
  memcpy(fscreen, fscreen2, 65536);
  for(i=0; i<200; i++)
    memcpy(vscreen+i*320+120, fscreen+i*256+256*28+28, 200);

  if(!f)
  { setpal(dog[1].palette);
    f=1;
  }
}
