#include <string.h>
#include "dip.h"
#include "feedback.h"
#include "graph.h"
#include "roto.h"

void pset(char sourcex, char sourcey, int destindex, char *dest, char *source);
#pragma AUX pset =         \
" mov cl,[ebx+esi] "       \
" mov ebx,edx "            \
" add ebx,eax "            \
" mov [ebx],cl "           \
parm [bl] [bh] [edx] [eax] [esi] \
modify [eax ebx cx edx esi];

bitmap wushroom;
static int angle=0, distance=2024, intensity=-128;
char screenz[10][64000];

void greenpalette()
{ int i;
  for(i=0; i<256; i++)
    outc(i, 0, i/4, 0);
}

void bumpmap(char *screen, char *vscreen)
{ int i, n;
  int q=0;
  static int p=0;

  if(dip[WUSHROOM3] && dip[WUSHROOM2])
  { waitretrace();
    memcpy(screen, vscreen, 64000);    
    return;
  }
  if(dip[WUSHROOM3])
  { for(i=1; i<63999-640; i++)
    { n=vscreen[i-1]-vscreen[i]+intensity;
      if(n<0) n=0;
      if(n>255) n=255;
      screenz[p][i]=n;//vscreen[i];
      if(++q==319) q=0, i++;
    }
  }
  if(dip[WUSHROOM2])
  { for(i=1; i<63999-640; i++)
      if(vscreen[i]) screenz[p][i]=vscreen[i];//vscreen[i];
  }
  else
    for(i=1; i<63999-640; i++)
    { n=vscreen[i-1]-vscreen[i]+intensity;
      if(n<0) n=0;
      if(n>255) n=255;
      if(vscreen[i]) screenz[p][i]=n;//vscreen[i];
      if(++q==319) q=0, i++;
    }
  waitretrace();
  memcpy(screen, screenz[p], 64000);
  if(p++>8) p=0;
}

void drawrotzoom(char *screen)
{ static int xv, yv, x, y, q;
  int i, j, ox, oy, n=0;
  char *image;

  if(!q)
  { if(dip[WUSHROOM]) greenpalette();
    else setpal(wushroom.palette);
    q=1;
  }

  image=wushroom.image;
  ox=x=320*65536*3+angle*65536;
  oy=y=200*65536*5;
  xv=sine[angle%2048]*2;
  yv=sine[(angle+256)%2048]*2;
  xv*=distance,xv/=1280;
  yv*=distance,yv/=1280;
  for(i=0; i<200; i++)
  { ox-=yv,oy+=xv;
    x=ox,y=oy;
    for(j=0; j<320; j++)
    { x+=xv,y+=yv;
      pset(x>>15,y>>15,n,vscreen,image);
      n++;
    }
  }
  bumpmap(screen, vscreen);
}

void initrotzoom()
{ wushroom=loadpcxlump("image.wushroom");
}

void advrotzoom(int frames)
{ static int distv=0;

  angle+=frames;
  distance+=distv;
  distv--;
  if(distance<1268)
    distv+=2;
  intensity+=frames;
  if(intensity>128) intensity=128;
}
