#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "graph.h"

typedef unsigned char uc;
typedef unsigned short us;
typedef float fp;

#define ORBITS 200
#define RESO   256
#define STEPS  512

unsigned char newpal[STEPS][768];
char jizz   [256][256];
char orbitsx[ORBITS][RESO];
char orbitsy[ORBITS][RESO];
int  starts [ORBITS];
char boogy  [256][256];
char woogy  [256][256];

int xa,ya,za,aa,na = 0;
int rgb[3], abc[3];
int up;

void loadpalette(int x) {
   int i;
   outp(0x3c8,0);
   for (i = 0; i < 768; i++)
       outp(0x3c9, newpal[x][i]);
}

unsigned char pal1[768];
unsigned char pal2[768];

void GenPalette(int r1, int g1, int b1, int r2, int g2, int b2) {
     int y = 0;
     double a, b, c, d, e, f;
     a = (double) r1;
     b = (double) g1;
     c = (double) b1;
     a /= 256.0;
     b /= 256.0;
     c /= 256.0;
     d = e = f = 0.0;
     for (y = 0; y < 768; y += 3) {
         pal1[ y ] = (unsigned char) d;
         pal1[y+1] = (unsigned char) e;
         pal1[y+2] = (unsigned char) f;
         d += a;
         e += b;
         f += c;
     }
     a = (double) r2;
     b = (double) g2;
     c = (double) b2;
     a /= 256.0;
     b /= 256.0;
     c /= 256.0;
     d = e = f = 0.0;
     for (y = 0; y < 768; y += 3) {
         pal2[ y ] = (unsigned char) d;
         pal2[y+1] = (unsigned char) e;
         pal2[y+2] = (unsigned char) f;
         d += a;
         e += b;
         f += c;
     }
}

// unsigned char newpal[STEPS][768];

void SmoothPalette() {
     int x = 0, y = 0;
     double a, b, c, d, e, f;
     for (y = 0; y < 768; y += 3) {
             a = (double) pal2[ y ] - (double) pal1[ y ];
             b = (double) pal2[y+1] - (double) pal1[y+1];
             c = (double) pal2[y+2] - (double) pal1[y+2];
             a /= STEPS;
             b /= STEPS;
             c /= STEPS;
             d = (double) pal1[ y ];
             e = (double) pal1[y+1];
             f = (double) pal1[y+2];
             for (x = 0; x < STEPS; x++) {
                  newpal[x][ y ] = d;
                  d += a;
                  newpal[x][y+1] = e;
                  e += b;
                  newpal[x][y+2] = f;
                  f += c;
             }
     }
}

void initializ() {
     int x,y;
     for (y=0;y<256;y++) {
         for (x=0;x<256;x++) {
             boogy[y][x]=0;
             woogy[y][x]=0;
             jizz [y][x]=0;
         }
     }
     for (y=0;y<ORBITS;y++) {
         starts[y]=0;
         for (x=0;x<RESO;x++) {
             orbitsy[y][x]=0;
             orbitsx[y][x]=0;
         }
     }
}

#pragma aux TextMode = \
" mov ax,0003h " \
" int 10h " \
modify [ax];

#pragma aux VideoMode = \
"mov AX, 0013H"\
"int 10H"\
modify [AX];

void SquareMode(void) {
     outp(0x03D4, 0x0011);
     outp(0x03D5, (inp(0x03D5)&0x7F));
     outp(0x03C2, 0x00E3);
     outp(0x03D4, 0x0000);
     outp(0x03D5, 0x005F);
     outp(0x03D4, 0x0001);
     outp(0x03D5, 0x003F);
     outp(0x03D4, 0x0002);
     outp(0x03D5, 0x0040);
     outp(0x03D4, 0x0003);
     outp(0x03D5, 0x0082);
     outp(0x03D4, 0x0004);
     outp(0x03D5, 0x004A);
     outp(0x03D4, 0x0005);
     outp(0x03D5, 0x009A);
     outp(0x03D4, 0x0006);
     outp(0x03D5, 0x0023);
     outp(0x03D4, 0x0007);
     outp(0x03D5, 0x00B2);
     outp(0x03D4, 0x0008);
     outp(0x03D5, 0x0000);
     outp(0x03D4, 0x0009);
     outp(0x03D5, 0x0061);
     outp(0x03D4, 0x0010);
     outp(0x03D5, 0x000A);
     outp(0x03D4, 0x0011);
     outp(0x03D5, 0x00AC);
     outp(0x03D4, 0x0012);
     outp(0x03D5, 0x00FF);
     outp(0x03D4, 0x0013);
     outp(0x03D5, 0x0020);
     outp(0x03D4, 0x0014);
     outp(0x03D5, 0x0040);
     outp(0x03D4, 0x0015);
     outp(0x03D5, 0x0007);
     outp(0x03D4, 0x0016);
     outp(0x03D5, 0x001A);
     outp(0x03D4, 0x0017);
     outp(0x03D5, 0x00A3);
     outp(0x03C4, 0x0001);
     outp(0x03C5, 0x0001);
     outp(0x03C4, 0x0004);
     outp(0x03C5, 0x000E);
     outp(0x03CE, 0x0005);
     outp(0x03CF, 0x0040);
     outp(0x03CE, 0x0006);
     outp(0x03CF, 0x0005);
}    

void zoom() {
     int xscalefactor,x,y,r,l,z;
     r=l=0;
     xscalefactor=248<<8; // 254<<24>>8
     z=0;
     x=(4<<16);
     for (y = (4<<16); y < (252<<16); y += xscalefactor, l++) {
         r=0;
         for (x = x&(1<<16)+(4<<16); x < (252<<16); x += xscalefactor, r++) {
               woogy[l][r]=boogy[y>>16][x>>16];
         }
     }
//     memcpy(woogy, jizz, 65536);
}

void uglyblur(void) {
    int x,y;
    char *Pointer, *Pointer2;;
    for (y=1;y<255;y++)  {
         Pointer = &(woogy[y][1]);
         Pointer2 = &(boogy[y][1]);
         for (x=1;x<255;x++,Pointer++,Pointer2++) {
              *Pointer2 = (( (*(Pointer+256) + *(Pointer-256) + *(Pointer+1) + *(Pointer-1)) >>2)+*Pointer)>>1;
         }
    }    
}


void makeorbit(us x1, us y1, us x2, us y2, us x3, us y3, us x4, us y4, us booby)
{
  us x = 0, y = 0, z = 0;
  fp dc, w1, w2, w3, w4, wv = 0;
  dc = 0.0;
  for (z = 0; z < RESO; z++) {
    dc += 1.0/RESO;
    wv = 1.0 - dc;
    w1 = wv * wv * wv;
    w2 = dc * (wv * wv) * 3;
    w3 = wv * (dc * dc) * 3;
    w4 = dc * dc * dc;

    x = x1 * w1 + x2 * w2 + x3 * w3 + x4 * w4;
    y = y1 * w1 + y2 * w2 + y3 * w3 + y4 * w4;

    orbitsx[booby][z]=x;
    orbitsy[booby][z]=y;
  }
}

void initugly() {
        rgb[0] = 255;
        rgb[1] = 128;
        rgb[2] = 128;
        abc[0] = 64;
        abc[1] = 255;
        abc[2] = 0;

//     VideoMode();
//     SquareMode();
     GenPalette(rgb[0], rgb[1], rgb[2], abc[0], abc[1], abc[2]);
     SmoothPalette();
     
     initializ();

     for (za=0;za<ORBITS;za++) {
          xa=rand()&0xFF;
          ya=rand()&0xFF;
          makeorbit(xa, ya, rand()&0xFF, rand()&0xFF, rand()&0xFF, rand()&0xFF, xa, ya, za);
          starts[za]=rand()%RESO;
     }

     up = 1;
}

void advugly() {
           static int n=0;
           if(!n)
           { SquareMode();
             n=1;
           } 
           if( up )
           {
               loadpalette( aa );
               for (za=0;za<ORBITS;za++) {
                   if (starts[za]>RESO) starts[za]=0;
                   woogy[(char)orbitsy[za][starts[za]]][(char)orbitsx[za][starts[za]]]=64;
                   starts[za]++;
               }
               uglyblur();
               zoom();
               memcpy(screen, woogy, 65536);
               xa++;
               aa++;
               if( aa == 511 )
               {
                up = 0;
               }
           }
           else {
               loadpalette( aa );
               for (za=0;za<ORBITS;za++) {
                   if (starts[za]>RESO) starts[za]=0;
                   woogy[(char)orbitsy[za][starts[za]]][(char)orbitsx[za][starts[za]]]=64;
                   starts[za]++;
               }
               uglyblur();
               zoom();
               memcpy(screen, woogy, 65536);
               xa++;
               aa--;
               if( aa == 0 )
               {
                up = 1;
               }
           }
     }

