#include <math.h>
#include "dip.h"
#include "feedback.h"
#include "graph.h"
#include "nethack.h"

#define OBJSIZE 16*16
point object[OBJSIZE];

bitmap ball;
static int angle=0;
char image[16*16];
char scroll[2][32]=
{ "This is a vector grape scroll.  ",
  "Grasp Will Smith or don't!@#$   "
};
char scc=0, scp=7;

void initvball()
{ int i, j, n=0;
  ball=loadpcxlump("image.grapeball");
  for(i=-64; i<64; i+=8)
    for(j=-64; j<64; j+=8)
    { image[n]=0;
      object[n].x=i;
      object[n].y=j;
      object[n++].z=-32;
    }
}

void sortpoints(point *obj, int size)
{ int i, j;
  point s;

  for(i=0; i<size-1; i++)
  { for(j=i+1; j<size; j++)
      if(obj[i].z>obj[j].z)
      { s=obj[i];
        obj[i]=obj[j];
        obj[j]=s;
      }
  }
}

void rotate(point *dest, point *src, int n, int ax, int ay)
{ int i, j=0;
  double tox, toy, toz;
  double tx, ty, tz;
  double cox, six, coy, siy;

  cox=cos(ax*3.1415/180);
  six=sin(ax*3.1415/180);
  coy=cos(ay*3.1415/180);
  siy=sin(ay*3.1415/180);

  for(i=0; i<n; i++)
  { tox=src[i].x;
    toy=src[i].y;
    toz=src[i].z;
    tz=toy*cox-toz*six;
    ty=toz*cox+toy*six;
    toy=ty; toz=tz;
    tx=tox*coy-toy*siy;
    ty=tox*siy+toy*coy;
    dest[i].x=tx;
    dest[i].y=ty;
    dest[i].z=tz;
    dest[i].end=image[j++];
  }
}

void drawvball()
{ int i, x, y;
  static point obj[OBJSIZE];  

  rotate(obj, object, OBJSIZE, angle, angle*2);
  sortpoints(obj, OBJSIZE);
  for(i=0; i<OBJSIZE; i++)
  { if(obj[i].end)
    { x=256*obj[i].x/(obj[i].z-256)+160;
      y=256*obj[i].y/(obj[i].z-256)+100;
      putbitmaptrans(vscreen, x-8, y-8, &ball);
    }
  }
}

void nextrow()
{ int i;
  char *p;

  for(i=16*16-1; i>15; i--) image[i]=image[i-16];
  p=font+scroll[dip[SCROLLER]][scc]*16;
  for(i=0; i<16; i++, p++)
    image[i]=(*p>>scp)&1;
  if(--scp==0) scp=8;
  if(scp==8 && scroll[0][scc]) scc++;
}

void advvball(int frames)
{ static int n=0;
  angle+=frames;
  n+=frames;
  while(n>2)
  { nextrow();
    n-=2;
  }
}
